package javax.swing.event;

import javax.swing.text.Element;
import javax.swing.text.Document;

public interface DocumentEvent
{
    public abstract int getOffset();
    
    public abstract int getLength();
    
    public abstract Document getDocument();
    
    public abstract DocumentEvent.EventType getType();
    
    public abstract DocumentEvent.ElementChange getChange(Element p0);
    
    public static final class EventType
    {
        public static final DocumentEvent.EventType INSERT;
        public static final DocumentEvent.EventType REMOVE;
        public static final DocumentEvent.EventType CHANGE;
        private String typeString;
        
        private EventType(String typeString) {
            this.typeString = typeString;
        }
        
        @Override
        public String toString() {
            return this.typeString;
        }
        
        static {
            INSERT = new DocumentEvent.EventType("INSERT");
            REMOVE = new DocumentEvent.EventType("REMOVE");
            CHANGE = new DocumentEvent.EventType("CHANGE");
        }
    }
    
    public interface ElementChange
    {
        public abstract Element getElement();
        
        public abstract int getIndex();
        
        public abstract Element[] getChildrenRemoved();
        
        public abstract Element[] getChildrenAdded();
    }
}
